import groovy.json.JsonSlurper
import groovy.json.JsonBuilder
import groovy.io.FileType
import com.urbancode.air.AirPluginTool;

def apTool = new AirPluginTool(this.args[0], this.args[1]);
def props = apTool.getStepProperties();

def configFile = props['configFile'].trim();
def outputFile = props['outputFile'].trim();
def cellName = props['cellName'].trim();
def nodeName = props['nodeName'].trim();
def nodeHostName = props['nodeHostName'].trim();
def serverName = props['serverName'].trim();
def clusterName = props['clusterName'].trim();


configFile = new File(configFile)
String configFileContents = configFile.getText('UTF-8')

if (serverName != ""){
  println "Templatizing the server name..."
  configFileContents = configFileContents.replace("/Servers/" + serverName + "/", "/Servers/@websphere.server@/")
  configFileContents = configFileContents.replace("(server):" + serverName, "(server):@websphere.server@")
}

if (clusterName != ""){
  println "Templatizing the cluster name..."
  configFileContents = configFileContents.replace("/ServerClusters/" + clusterName + "/", "/ServerClusters/@websphere.cluster@/")
  configFileContents = configFileContents.replace("(cluster):" + clusterName, "(cluster):@websphere.cluster@")
}

if (nodeHostName != ""){
  println "Templatizing the node host name..."
  configFileContents = configFileContents.replace("\"" + nodeHostName + "\"", "\"@websphere.node.hostname@\"")
}

if (nodeName != ""){
  println "Templatizing the node name..."
  configFileContents = configFileContents.replace("/Nodes/" + nodeName + "/Servers/", "/Nodes/@websphere.node@/Servers/")
  configFileContents = configFileContents.replace("(node):" + nodeName, "(node):@websphere.node@")
}

if (cellName != ""){
  println "Templatizing the cell name..."
  configFileContents = configFileContents.replace("/" + cellName + "/", "/@websphere.cell@/")
  configFileContents = configFileContents.replace("(cell):" + cellName, "(cell):@websphere.cell@")
}

// just to be safe, tokenize anything we may have missed
if (serverName != ""){
  configFileContents = configFileContents.replace(serverName, "@websphere.server@")
}

if (clusterName != ""){
  configFileContents = configFileContents.replace(clusterName, "@websphere.cluster@")
}

if (nodeHostName != ""){
  configFileContents = configFileContents.replace(nodeHostName, "@websphere.node.hostname@")
}

if (nodeName != ""){
  configFileContents = configFileContents.replace(nodeName, "@websphere.node@")
}

if (cellName != ""){
  configFileContents = configFileContents.replace(cellName, "@websphere.cell@")
}

// create output file dir if needed
outputFile = new File(outputFile)
outputFileDir = new File(outputFile.getParent())
if (!outputFileDir.exists()) {
  outputFileDir.mkdirs()
}
// delete the output file if it already exists
if (outputFile.exists()) {
  outputFile.delete()
}

// write the results to the outputFile
println "Creating new configuration file: " + outputFile
new File(outputFile.getParent()+File.separator+outputFile.getName()).write(configFileContents, 'UTF-8')

